/*
created 20110915 by whygee@ygdes.com
 docs/16-32.js

Lists the YASEP32 and YASEP16 opcodes
*/

DOC_GEN.valid_keys["16-32"]={
  menuTitle:"16&nbsp;vs&nbsp;32&nbsp;bits",
  onLoad: function(cont, h){
    var f, Usage16=[], Usage32=[];

    // scan the list of opcodes
    for (var name in Y.table_opcode) {
      if (Y.table_opcode[name].forms>0) {
        f=Y.table_opcode[name].flags;
        if (Y.YASEP16_ONLY & f)
          Usage16[Usage16.length]=Y.decorate_opcode(name)+' ';
        if (Y.YASEP32_ONLY & f)
          Usage32[Usage32.length]=Y.decorate_opcode(name)+' ';
      }
    }

    if(Usage16.length)
      getById("y16","div",cont).innerHTML=Usage16.sort().join(" ");
    if(Usage32.length)
      getById("y32","div",cont).innerHTML=Usage32.sort().join(" ");
  }
};

winman.register_window("doc/16-32",DOC_GEN.start);

