/* yasep/tool/asm.js
 created mar. sept. 13 08:49:01 CEST 2011
 The successor of the "floating assembler window" :-)
 version lun. oct. 17 05:51:23 CEST 2011 : adding stuff from yasep/JSgui/floating_asm.js
 */

asmwin={
  win: null,
  size_id: null,

  update_asm: function(){
    if (Yasep_ASM.encode_YASEP_instruction(document.asm_form.value_asm.value, asmwin.ASM)) {
      document.hex_form.value_hex.value=int2hex(asmwin.ASM.encoded_instruction,
        2*asmwin.ASM.encoded_size_bytes-1,2*asmwin.ASM.encoded_size_bytes-1);
      asmwin.size_id.innerHTML="size : "+asmwin.ASM.encoded_size_bytes+" bytes";
    }
    else {
      document.hex_form.value_hex.value="";
      asmwin.size_id.innerHTML="";
    }
  },

  update_hex: function(){
    Yasep_DISASM(str2int(document.hex_form.value_hex.value), asmwin.DISASM);
    if (asmwin.DISASM.form!=null) {
      document.asm_form.value_asm.value=asmwin.DISASM.instruction;
      asmwin.size_id.innerHTML="size : "+asmwin.DISASM.size_bytes+" bytes";
    }
    else {
      document.asm_form.value_asm.value="error";
      asmwin.size_id.innerHTML="";
    }
  },

  trigger_asm: function(loc){
    if (loc!='') {
      // some escape sequence cleanup :
      loc=loc.replace(/[%]20/g,' ').replace(/[&][Nn][Bb][Ss][Pp][;]/g,' ');
      var i=loc.indexOf('?');
      if (i==1){
        var a=loc.slice(2);
        if (loc[0]=="a") {
          if (a) {
            document.asm_form.value_asm.value=unescape(a);
            asmwin.update_asm();
          }
        }
        else
          if (loc[0]=="d") {
            if (a) {
              document.hex_form.value_hex.value=unescape(a);
              asmwin.update_hex();
            }
          }
      }
    }
  },

  start: function() {
    asmwin.cont=document.createElement("DIV");
    asmwin.cont.innerHTML=import_htmi("tool/asm");
    // modify the <a> tags to change the style and hook the proper handling routines
    winman.patchInnerLinks(asmwin.cont);
    var t, h=getByClass("hiddenDiv","DIV",asmwin.cont);
    asmwin.win = ygwm.new_window(
       hiddenText(0,h), null, asmwin.cont,
       600, 400, 250, 150, false, true, true, true, false, "doc_cygr");
   // X & Y should be changed if a click opened the window

    asmwin.size_id=getById("ASM_size_id","SPAN",asmwin.cont);
    asmwin.messages=getById("ASM_messages","DIV",asmwin.cont);
    var a=message_FIFO(asmwin.messages);
    asmwin.ASM   = new    ASM_context(a);
    asmwin.DISASM= new DISASM_context(a);
    a('blue', hiddenText(1,h)); // first message, remove the error message.

    asmwin.win.trigger=asmwin.trigger_asm;

    return asmwin.win;
  },

  init_obj: function(){
    asmwin.menuItem = menu.subMenuItem(menu.mainMenuItem("Tools"),"Assembler", "tool/asm");
  }
}

winman.register_window("tool/asm",asmwin.start);
